package pwc.taxtech.atms.dto.vatdto;

import lombok.Getter;
import org.apache.poi.ss.formula.OperationEvaluationContext;
import org.apache.poi.ss.formula.eval.EvaluationException;
import org.apache.poi.ss.formula.eval.ValueEval;

import static pwc.taxtech.atms.common.util.FormulaUtil.resolverInteger;
import static pwc.taxtech.atms.common.util.FormulaUtil.resolverString;

@Getter
public class BBParasBo {
    private String reportCode;
    private Integer columnIndex;
    private Integer rowIndex;
    private Integer period;
    private Integer year;

    public BBParasBo(ValueEval[] args, OperationEvaluationContext ec) throws EvaluationException {
        reportCode = resolverString(args, ec, 0);
        try {
            columnIndex = resolverInteger(args, ec, 1);
        } catch (Exception e) {
            String columnStr = resolverString(args, ec, 1);
            int rtn = 0;
            columnStr = columnStr.toLowerCase();
            char[] excelCol = columnStr.toCharArray();
            for (int i = columnStr.length() - 1; i >= 0; i--) {
                if (excelCol[i] >= 'A' && excelCol[i] <= 'Z') {
                    rtn += ((int) Math.pow(26, excelCol.length - 1 - i) * (excelCol[i] - 64));
                } else {
                    rtn = -1;
                }
            }
            columnIndex = rtn;
        }
        rowIndex = resolverInteger(args, ec, 2);
        period = args.length >= 4 ? resolverInteger(args, ec, 3) : 0;
        year = args.length == 5 ? resolverInteger(args, ec, 4) : 0;
    }

    public void disCount() {
        rowIndex--;
        columnIndex--;
    }

    public BBParasBo(BBParasBo otherBo, int period, int curYear) {
        this.reportCode = otherBo.reportCode;
        this.columnIndex = otherBo.getColumnIndex();
        this.rowIndex = otherBo.rowIndex;
        this.period = period;
        this.year = curYear;
    }
}
